import React, { Component } from 'react';
import PropTypes from 'prop-types';

var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();







var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};



var inherits = function (subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
};











var possibleConstructorReturn = function (self, call) {
  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return call && (typeof call === "object" || typeof call === "function") ? call : self;
};

var CONTEXT_TYPES = {
  subscribeToForwardMethods: PropTypes.func.isRequired
};

var forwardMethodsOuter = function forwardMethodsOuter(_ref) {
  var methods = _ref.methods;
  return function (WrappedComponent) {
    var WithForwardedMethodsOuter = function (_Component) {
      inherits(WithForwardedMethodsOuter, _Component);

      function WithForwardedMethodsOuter() {
        var _ref2;

        var _temp, _this, _ret;

        classCallCheck(this, WithForwardedMethodsOuter);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = possibleConstructorReturn(this, (_ref2 = WithForwardedMethodsOuter.__proto__ || Object.getPrototypeOf(WithForwardedMethodsOuter)).call.apply(_ref2, [this].concat(args))), _this), _initialiseProps.call(_this), _temp), possibleConstructorReturn(_this, _ret);
      }

      createClass(WithForwardedMethodsOuter, [{
        key: 'getChildContext',
        value: function getChildContext() {
          return {
            subscribeToForwardMethods: this.subscribe
          };
        }
      }, {
        key: 'render',
        value: function render() {
          return React.createElement(WrappedComponent, this.props);
        }
      }]);
      return WithForwardedMethodsOuter;
    }(Component);

    WithForwardedMethodsOuter.childContextTypes = CONTEXT_TYPES;

    var _initialiseProps = function _initialiseProps() {
      var _this2 = this;

      this.callbacksByMethod = {};

      this.subscribe = function (innerRef) {
        methods.forEach(function (method) {
          _this2.callbacksByMethod[method] = function () {
            return innerRef[method].apply(innerRef, arguments);
          };
        });
        return function () {
          _this2.callbacksByMethod = {};
        };
      };
    };

    methods.forEach(function (method) {
      WithForwardedMethodsOuter.prototype[method] = function () {
        var _callbacksByMethod;

        return (_callbacksByMethod = this.callbacksByMethod)[method].apply(_callbacksByMethod, arguments);
      };
    });

    return WithForwardedMethodsOuter;
  };
};

var forwardMethodsInner = function forwardMethodsInner() {
  return function (WrappedComponent) {
    var WithForwardedMethodsInner = function (_Component2) {
      inherits(WithForwardedMethodsInner, _Component2);

      function WithForwardedMethodsInner() {
        classCallCheck(this, WithForwardedMethodsInner);
        return possibleConstructorReturn(this, (WithForwardedMethodsInner.__proto__ || Object.getPrototypeOf(WithForwardedMethodsInner)).apply(this, arguments));
      }

      createClass(WithForwardedMethodsInner, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
          this.unsubscribe = this.context.subscribeToForwardMethods(this.ref);
        }
      }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
          this.unsubscribe();
        }
      }, {
        key: 'render',
        value: function render() {
          var _this4 = this;

          return React.createElement(WrappedComponent, _extends({ ref: function ref(_ref3) {
              return _this4.ref = _ref3;
            } }, this.props));
        }
      }]);
      return WithForwardedMethodsInner;
    }(Component);

    WithForwardedMethodsInner.contextTypes = CONTEXT_TYPES;


    return WithForwardedMethodsInner;
  };
};

export { forwardMethodsOuter, forwardMethodsInner };
